AutoHello = class();

function AutoHello:Constructor()
	self:GetListMenu();
	self:InitChatLogger();
	self.total = 0;
	settings.hello = {};
	settings.hello[1] = "Hey ";
	settings.hello[2] = "Hello ";
	settings.hello[3] = "Plop ";
end

function AutoHello:InitChatLogger()
	if(Turbine.Chat.receivedListerners == nil) then
		Turbine.Chat.receivedListerners = {};
		Turbine.Chat.Received = function (sender, args)
			for i, j in pairs(Turbine.Chat.receivedListerners) do
				j:OnReceived(sender, args);
			end
		end
		-- local tempMessage = tostring(args.Message);
	end
	if (Turbine.Chat.receivedListerners ~= nil) then
		for i, j in pairs(Turbine.Chat.receivedListerners) do
			if(j==self) then return; end
		end
		table.insert(Turbine.Chat.receivedListerners, self);
		--Turbine.Shell.WriteLine( "DiceLister ECHO: "..table.getn(Turbine.Chat.receivedListerners));
	end	
end

function AutoHello:OnReceived(sender, args)
	if args.ChatType == Turbine.ChatType.Kinship then
		local tempMessage = tostring(args.Message);
		local x, y, name, value = string.find(tempMessage, "^(.*) est en ligne.*");
		--Turbine.Shell.WriteLine("<rgb=#FF5CCD>"..tempMessage.."</rgb>"); -- OK
		if(name~=nil ) then
			local nb = self:AddCounter(name);
		end
		x, y, name, value = string.find(tempMessage, ".*\062(.*)\060.*");
		if(name~=nil ) then
			local leaf = self:GetLeaf(name);
			if(leaf ~= nil) then
				if(leaf.talked ~= true) then
					self:Share(name);
					leaf.talked = true;
				end
			end
		end

	end
end

function AutoHello:AddCounter(name)
	local connectTime = Turbine.Engine.GetDate();
	local leaf = self:GetLeaf(name);
	if(leaf==nil)then
		leaf = Turbine.UI.MenuItem(name);
		leaf.name = name;
		leaf.value = connectTime;
		leaf:SetText(name.." : "..connectTime.Hour.."H"..connectTime.Minute.." "..connectTime.Second.."sec");
		self.kmenu:GetItems():Add(leaf);
		leaf.Click = function (sender, args) 
			self:Share(name);
		end
		--self:Share(name);
	else
		leaf.value = connectTime;
		leaf:SetText(name.." : "..connectTime.Hour.."H"..connectTime.Minute.." "..connectTime.Second.."sec");
	end
	
	return leaf.nb;
end


function AutoHello:UpdateLeafText(leaf)
	if(leaf~=nil and leaf.name~=nil) then
		--leaf:SetText(leaf.pos.." "..leaf.name..": "..leaf.nb.." ["..math.floor(100*leaf.nb/self.total).."%]");
		local subvalue = "";
		if(leaf.subvalue~=nil) then
			subvalue = "  ("..leaf.subvalue..")";
		end
		leaf:SetText(leaf.name..": "..leaf.value..subvalue);
	end
end

function AutoHello:GetLeaf(name)
	for i=1, self.kmenu:GetItems():GetCount(), 1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name==name) then
			return leaf;
		end
	end
	return nil;
end

function AutoHello:GetListMenu()
	if(self.kmenu == nil) then
		self.kmenu = Turbine.UI.MenuItem("Auto Hello");
		local dMenuList = self.kmenu:GetItems();
		local resetMenuItem = Turbine.UI.MenuItem( "Réinitialiser");
		resetMenuItem.Click = function (sender, args)
			self:Reset();
		end		
		dMenuList:Add(resetMenuItem);

		local talkativeItem = Turbine.UI.MenuItem( "Activer automatiquement" );
		talkativeItem:SetChecked(settings.helloTalkativeItem~=false);
		talkativeItem.Click = function (sender, args)
			talkativeItem:SetChecked(not talkativeItem:IsChecked());
			settings.helloTalkativeItem = talkativeItem:IsChecked();
			SaveSettings();
		end		
		dMenuList:Add(talkativeItem);


		if(_DEBUG~=nil and _DEBUG==true) then
			local test1MenuItem = Turbine.UI.MenuItem( "Add Toto");
			test1MenuItem.Click = function (sender, args)
				self:AddCounter("Toto", 15, true);
			end
			dMenuList:Add(test1MenuItem);
			local test2MenuItem = Turbine.UI.MenuItem( "Add Tata");
			test2MenuItem.Click = function (sender, args)
				self:AddCounter("Tata", 49, true);
			end
			dMenuList:Add(test2MenuItem);
			local test3MenuItem = Turbine.UI.MenuItem( "Add Titi");
			test3MenuItem.Click = function (sender, args)
				self:AddCounter("Titi", 85, true);
			end
			dMenuList:Add(test3MenuItem);
		end
	end
	return self.kmenu;
end

function AutoHello:Share(name)
	if(settings.helloTalkativeItem~=false) then
		local id = math.random(2)+1;
		createBubblePopupForSharing(name.."\nvient de se connecter !\nOn lui dit bonjour ?!", settings.hello[id]..name.." !", "/k"):SetVisible(true);
	end
end

function AutoHello:Reset()
	self.total = 0;
	for i=self.kmenu:GetItems():GetCount(), 1, -1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name~=nil) then
			self.kmenu:GetItems():RemoveAt(i);			
		end
	end
	self.total = 0;
end