DPSRecorder = class();

function DPSRecorder:Constructor()
	self:GetMenu();
	self:InitChatLogger();
	self.total = 0;
end

function DPSRecorder:InitChatLogger()
	if(Turbine.Chat.receivedListerners == nil) then
		Turbine.Chat.receivedListerners = {};
		Turbine.Chat.Received = function (sender, args)
			for i, j in pairs(Turbine.Chat.receivedListerners) do
				j:OnReceived(sender, args);
			end
		end
		-- local tempMessage = tostring(args.Message);
	end
	if (Turbine.Chat.receivedListerners ~= nil) then
		for i, j in pairs(Turbine.Chat.receivedListerners) do
			if(j==self) then return; end
		end
		table.insert(Turbine.Chat.receivedListerners, self);
		--Turbine.Shell.WriteLine( "DPSRecorder ECHO: "..table.getn(Turbine.Chat.receivedListerners));
	end	
end

function DPSRecorder:OnReceived(sender, args)
	if args.ChatType == Turbine.ChatType.PlayerCombat then
		local tempMessage = tostring(args.Message);
		--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Message : "..tempMessage.."</rgb>");
		--Walm a infligé un coup critique avec Attaque sauvage sur l’Ouargue de Gundabad pour 16,438 points de type Ouistrenesse à l'entité Moral
		
		--local x, y, wbName = string.find(tempMessage, "^Termin\195\169[\194\160%s]*:[\194\160%s]*Troupe de guerre[\194\160%s]*:(.*)$");			
		local x, y, damageValue = string.find(tempMessage, "^%s*pour (.*) points%s*$");			
		--local x, y, damageValue = string.find(tempMessage, "^(.*)%i(.*)$");	
		--local damageValue = string.find(tempMessage, "%i");
		if(damageValue ~= nil) then
			Turbine.Shell.WriteLine("<rgb=#FF5CCD>DAMAGE : "..damageValue.."</rgb>"); -- OK
			-- createBubblePopup("Ha ha, s'pèce de noob !"):SetVisible(true);
			-- local nb = self:AddCounter(Turbine.Gameplay.LocalPlayer.GetInstance():GetName(), 1, false);
		end
		-- x, y, wbName = string.find(tempMessage, "^(.*) a péri.$");	
		-- if(wbName ~= nil) then
			-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>"..wbName.." est mort</rgb>"); -- A tester
			-- createBubblePopup("Ton pote "..wbName.." est mort !\nNOOOB"):SetVisible(true);
			-- local nb = self:AddCounter(wbName, 1, false);
		-- end
		-- -- x, y = string.find(tempMessage, "^Vous avez succombé à vos blessures.$");	
		-- -- if(x ~= nil) then
			-- -- Turbine.Shell.WriteLine("<rgb=#FF5CCD>Vous êtes mort, lol</rgb>");
		-- -- end
		-- x, y = string.find(tempMessage, "^Un incident vous a réduit à l'impuissance.$");	-- OK
		-- if(x ~= nil) then
			-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>J'ai glissé Chef !!!</rgb>");
			-- createBubblePopup("\"J'ai glissé Chef !!!\"\nGniark gniark gniark"):SetVisible(true);
			-- -- bindedSongPopup = createBubblePopup(songName);
			-- -- bindedSongPopup:SetVisible(true);
			-- local nb = self:AddCounter(Turbine.Gameplay.LocalPlayer.GetInstance():GetName(), 1, false);
		-- end			
	end
end

function DPSRecorder:AddCounter(name, nb, force)
	-- test membership
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>name = "..name.."</rgb>");
	local player = Turbine.Gameplay.LocalPlayer:GetInstance();
	if(player:GetName()==name or self:IsTeamMember(name) or force==true) then
		self.total = self.total+nb;
		local leaf = self:GetLeaf(name);
		if(leaf==nil)then
			leaf = Turbine.UI.MenuItem(name);
			leaf.name = name;
			leaf.nb = nb;
			leaf.pos = 1;
			for i=1, self.kmenu:GetItems():GetCount(), 1 do
				local bleaf =  self.kmenu:GetItems():Get(i);
				if(bleaf~=nil and bleaf.name~=nil and bleaf.nb<nb) then
					self.kmenu:GetItems():Insert(i, leaf);
					break;
				elseif(bleaf~=nil and bleaf.name==nil) then
					self.kmenu:GetItems():Insert(i, leaf);
					break;
				end
			end
		else
			leaf.nb = leaf.nb+nb;
			for i=self.kmenu:GetItems():IndexOf(leaf)-1, 1, -1 do
				local bleaf =  self.kmenu:GetItems():Get(i);
				if(bleaf~=nil and bleaf.name~=nil) then
					--Turbine.Shell.WriteLine("<rgb=#FF5CCD>leaf.name="..leaf.name.." bleaf.name="..bleaf.name.."</rgb>");
					if(bleaf.nb<leaf.nb) then
						self.kmenu:GetItems():Set(i, leaf);
						self.kmenu:GetItems():Set(i+1, bleaf);
					end
				end
			end
		end
		
		-- update pos
		-- for i=self.kmenu:GetItems():GetCount(), 1, -1 do
			-- local leaf1 = self.kmenu:GetItems():Get(i);
			-- if(leaf1~=nil and leaf1.name~=nil) then
				-- for j=i-1, 1, -1 do
				
				-- end
			-- end
		-- end	
		
		-- Update texts
		for i=1, self.kmenu:GetItems():GetCount(), 1 do
			local leaf = self.kmenu:GetItems():Get(i);
			if(leaf~=nil and leaf.name~=nil) then
				--Turbine.Shell.WriteLine("<rgb=#FF5CCD>UPDATE "..leaf.name.."</rgb>");
				self:UpdateLeafText(leaf);
			end
		end	
		return leaf.nb;
	end
	return 0;
end

function DPSRecorder:IsTeamMember(playerName)
	local player = Turbine.Gameplay.LocalPlayer:GetInstance();
	if(player == nil or player:GetParty()==nil) then
		return false;
	end
	local party = player:GetParty();
	for i=1, party:GetMemberCount(), 1 do
		if(party:GetMember(i):GetName()==playerName) then
			return true;
		end
	end
	return false;
end

function DPSRecorder:UpdateLeafText(leaf)
	if(leaf~=nil and leaf.name~=nil) then
		--leaf:SetText(leaf.pos.." "..leaf.name..": "..leaf.nb.." ["..math.floor(100*leaf.nb/self.total).."%]");
		leaf:SetText(leaf.name..": "..leaf.nb.." ["..math.floor(100*leaf.nb/self.total).."%]");
	end
end

function DPSRecorder:GetLeaf(name)
	for i=1, self.kmenu:GetItems():GetCount(), 1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name==name) then
			return leaf;
		end
	end
	return nil;
end

function DPSRecorder:GetMenu()
	if(self.kmenu == nil) then
		self.kmenu = Turbine.UI.MenuItem("Compteur de Morts");
		local dMenuList = self.kmenu:GetItems();
		local shareMenuItem = Turbine.UI.MenuItem( "Partager ...");
		local shareCommMenuItem = Turbine.UI.MenuItem( "... à la communauté");
		shareCommMenuItem.Click = function (sender, args)
			self:Share("/comm");
		end		
		shareMenuItem:GetItems():Add(shareCommMenuItem);
		local shareRaidMenuItem = Turbine.UI.MenuItem( "... au raid");
		shareRaidMenuItem.Click = function (sender, args)
			self:Share("/ra");
		end		
		shareMenuItem:GetItems():Add(shareRaidMenuItem);	
				local shareConfMenuItem = Turbine.UI.MenuItem( "... à la confrérie");
		shareConfMenuItem.Click = function (sender, args)
			self:Share("/conf");
		end		
		shareMenuItem:GetItems():Add(shareConfMenuItem);	
		dMenuList:Add(shareMenuItem);
		local resetMenuItem = Turbine.UI.MenuItem( "Réinitialiser");
		resetMenuItem.Click = function (sender, args)
			self:Reset();
		end		
		dMenuList:Add(resetMenuItem);		
		if(_DEBUG~=nil and _DEBUG==true) then
			local test1MenuItem = Turbine.UI.MenuItem( "Add Toto");
			test1MenuItem.Click = function (sender, args)
				self:AddCounter("Toto", 1, true);
			end
			dMenuList:Add(test1MenuItem);
			local test2MenuItem = Turbine.UI.MenuItem( "Add Tata");
			test2MenuItem.Click = function (sender, args)
				self:AddCounter("Tata", 1, true);
			end
			dMenuList:Add(test2MenuItem);
			local test3MenuItem = Turbine.UI.MenuItem( "Add Titi");
			test3MenuItem.Click = function (sender, args)
				self:AddCounter("Titi", 1, true);
			end
			dMenuList:Add(test3MenuItem);
		end
	end
	return self.kmenu;
end

function DPSRecorder:Share(canal)
	local shareMsg = "<rgb=#FF0000>"..FromUTF8("Voici le palmarès des Morts par BlablaCrane :").."<rgb=#FF5CCD>";
	local count = 0;
	for i=1, self.kmenu:GetItems():GetCount(), 1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name~=nil) then
			shareMsg = shareMsg.."\n"..i.." - "..leaf.name.." : "..leaf.nb.." ("..math.floor(100*leaf.nb/self.total).."%)";
			count = count+1;
		end
	end
	if(count==0) then
		shareMsg = shareMsg.."\n".. FromUTF8("Aucun mort n'a été detecté ! GG !");
	end

	createBubblePopupForSharing("Qui ne Shwing Shwing pas\nn'est pas CHAMPION !", shareMsg, canal):SetVisible(true);
end

function DPSRecorder:Reset()
	self.total = 0;
	for i=self.kmenu:GetItems():GetCount(), 1, -1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name~=nil) then
			self.kmenu:GetItems():RemoveAt(i);			
		end
	end
	self.total = 0;
end