KillCounter = class();

function KillCounter:Constructor()
	self:GetKillMenu();
	self:InitChatLogger();
	self.total = 0;
end

function KillCounter:InitChatLogger()
	if(Turbine.Chat.receivedListerners == nil) then
		Turbine.Chat.receivedListerners = {};
		Turbine.Chat.Received = function (sender, args)
			for i, j in pairs(Turbine.Chat.receivedListerners) do
				j:OnReceived(sender, args);
			end
		end
		-- local tempMessage = tostring(args.Message);
	end
	if (Turbine.Chat.receivedListerners ~= nil) then
		for i, j in pairs(Turbine.Chat.receivedListerners) do
			if(j==self) then return; end
		end
		table.insert(Turbine.Chat.receivedListerners, self);
		--Turbine.Shell.WriteLine( "KillCounter ECHO: "..table.getn(Turbine.Chat.receivedListerners));
	end	
end

function KillCounter:OnReceived(sender, args)
	if args.ChatType == Turbine.ChatType.Death then
		local tempMessage = tostring(args.Message);
		--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Message : "..tempMessage.."</rgb>");
		local x, y, wbName = string.find(tempMessage, "^Votre coup puissant a vaincu (.*).$");			
		if(wbName ~= nil) then
			local nb = self:AddCounter(Turbine.Gameplay.LocalPlayer.GetInstance():GetName(), 1, false);
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Vous avez tué : "..wbName.." => ".. nb .."</rgb>"); -- OK
			
		else 
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>wbName2 essai</rgb>");
			x, y, wbName, wbName2 = string.find(tempMessage, "^(.*) a vaincu (.*).$");		
			if(wbName~=nil) then
				local nb = self:AddCounter(wbName, 1, false);				
				if (nb>0) then
					--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Votre collegue ".. wbName .." a tué : "..wbName2.." => "..nb.."</rgb>"); -- OK
				end
			end
		end
		
	end
end

function KillCounter:AddCounter(name, nb, force)
	-- test membership
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>name = "..name.."</rgb>");
	local player = Turbine.Gameplay.LocalPlayer:GetInstance();
	if(player:GetName()==name or self:IsTeamMember(name) or force==true) then
		self.total = self.total+nb;
		local leaf = self:GetLeaf(name);
		if(leaf==nil)then
			leaf = Turbine.UI.MenuItem(name);
			leaf.name = name;
			leaf.nb = nb;
			leaf.pos = 1;
			for i=1, self.kmenu:GetItems():GetCount(), 1 do
				local bleaf =  self.kmenu:GetItems():Get(i);
				if(bleaf~=nil and bleaf.name~=nil and bleaf.nb<nb) then
					self.kmenu:GetItems():Insert(i, leaf);
					break;
				elseif(bleaf~=nil and bleaf.name==nil) then
					self.kmenu:GetItems():Insert(i, leaf);
					break;
				end
			end
		else
			leaf.nb = leaf.nb+nb;
			for i=self.kmenu:GetItems():IndexOf(leaf)-1, 1, -1 do
				local bleaf =  self.kmenu:GetItems():Get(i);
				if(bleaf~=nil and bleaf.name~=nil) then
					--Turbine.Shell.WriteLine("<rgb=#FF5CCD>leaf.name="..leaf.name.." bleaf.name="..bleaf.name.."</rgb>");
					if(bleaf.nb<leaf.nb) then
						self.kmenu:GetItems():Set(i, leaf);
						self.kmenu:GetItems():Set(i+1, bleaf);
					end
				end
			end
		end
		
		-- update pos
		-- for i=self.kmenu:GetItems():GetCount(), 1, -1 do
			-- local leaf1 = self.kmenu:GetItems():Get(i);
			-- if(leaf1~=nil and leaf1.name~=nil) then
				-- for j=i-1, 1, -1 do
				
				-- end
			-- end
		-- end	
		
		-- Update texts
		for i=1, self.kmenu:GetItems():GetCount(), 1 do
			local leaf = self.kmenu:GetItems():Get(i);
			if(leaf~=nil and leaf.name~=nil) then
				--Turbine.Shell.WriteLine("<rgb=#FF5CCD>UPDATE "..leaf.name.."</rgb>");
				self:UpdateLeafText(leaf);
			end
		end	
		return leaf.nb;
	end
	return 0;
end

function KillCounter:IsTeamMember(playerName)
	local player = Turbine.Gameplay.LocalPlayer:GetInstance();
	if(player == nil or player:GetParty()==nil) then
		return false;
	end
	local party = player:GetParty();
	for i=1, party:GetMemberCount(), 1 do
		if(party:GetMember(i):GetName()==playerName) then
			return true;
		end
	end
	return false;
end

function KillCounter:UpdateLeafText(leaf)
	if(leaf~=nil and leaf.name~=nil) then
		--leaf:SetText(leaf.pos.." "..leaf.name..": "..leaf.nb.." ["..math.floor(100*leaf.nb/self.total).."%]");
		leaf:SetText(leaf.name..": "..leaf.nb.." ["..math.floor(100*leaf.nb/self.total).."%]");
	end
end

function KillCounter:GetLeaf(name)
	for i=1, self.kmenu:GetItems():GetCount(), 1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name==name) then
			return leaf;
		end
	end
	return nil;
end

function KillCounter:GetKillMenu()
	if(self.kmenu == nil) then
		self.kmenu = Turbine.UI.MenuItem("Compteur de kills");
		local dMenuList = self.kmenu:GetItems();

		local shareMenuItem = Turbine.UI.MenuItem( "Partager ...");
		local shareCommMenuItem = Turbine.UI.MenuItem( "... à la communauté");
		shareCommMenuItem.Click = function (sender, args)
			self:Share("/f");
		end		
		shareMenuItem:GetItems():Add(shareCommMenuItem);
		local shareRaidMenuItem = Turbine.UI.MenuItem( "... au raid");
		shareRaidMenuItem.Click = function (sender, args)
			self:Share("/ra");
		end		
		shareMenuItem:GetItems():Add(shareRaidMenuItem);	
				local shareConfMenuItem = Turbine.UI.MenuItem( "... à la confrérie");
		shareConfMenuItem.Click = function (sender, args)
			self:Share("/k");
		end		
		shareMenuItem:GetItems():Add(shareConfMenuItem);	
		dMenuList:Add(shareMenuItem);
		local resetMenuItem = Turbine.UI.MenuItem( "Réinitialiser");
		resetMenuItem.Click = function (sender, args)
			self:Reset();
		end		
		dMenuList:Add(resetMenuItem);		
		if(_DEBUG~=nil and _DEBUG==true) then
			local test1MenuItem = Turbine.UI.MenuItem( "Add Toto");
			test1MenuItem.Click = function (sender, args)
				self:AddCounter("Toto", 1, true);
			end
			dMenuList:Add(test1MenuItem);
			local test2MenuItem = Turbine.UI.MenuItem( "Add Tata");
			test2MenuItem.Click = function (sender, args)
				self:AddCounter("Tata", 1, true);
			end
			dMenuList:Add(test2MenuItem);
			local test3MenuItem = Turbine.UI.MenuItem( "Add Titi");
			test3MenuItem.Click = function (sender, args)
				self:AddCounter("Titi", 1, true);
			end
			dMenuList:Add(test3MenuItem);
		end
	end
	return self.kmenu;
end

function KillCounter:Share(canal)
	local shareMsg = "<rgb=#FF0000>"..FromUTF8("Voici le palmarès des Kills par BlablaCrane :").."<rgb=#FF5CCD>";
	local count = 0;
	for i=1, self.kmenu:GetItems():GetCount(), 1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name~=nil) then
			shareMsg = shareMsg.."\n"..i.." - "..leaf.name.." : "..leaf.nb.." ("..math.floor(100*leaf.nb/self.total).."%)";
			count = count+1;
		end
	end
	if(count==0) then
		shareMsg = shareMsg.."\n".. FromUTF8("Aucun kill n'a été detecté ! Bande de MOULES !");
	end

	createBubblePopupForSharing("Gniark Gniark Gniark\nVoyons voir qui m'a rejoint dans le Royaume des Morts...", shareMsg, canal):SetVisible(true);
end

function KillCounter:Reset()
	self.total = 0;
	for i=self.kmenu:GetItems():GetCount(), 1, -1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name~=nil) then
			self.kmenu:GetItems():RemoveAt(i);			
		end
	end
	self.total = 0;
end