import "Turbine.Gameplay";
import "WalmPlugins.BlaBlaCrane.src.Turbine";

import "WalmPlugins.BlaBlaCrane.src.UTF";
import "WalmPlugins.BlaBlaCrane.src.StringLib";
import "WalmPlugins.BlaBlaCrane.src.QuickLauncher";
import "WalmPlugins.BlaBlaCrane.src.Saving";
import "WalmPlugins.BlaBlaCrane.src.ConfigDialog";
import "WalmPlugins.BlaBlaCrane.src.BubblePopup";

RtmCommand = Turbine.ShellCommand();

_DEBUG = false;

function RtmCommand:Execute( command, arguments )
	if ( arguments == "?" or arguments == "help" or arguments == "man") then
		Turbine.Shell.WriteLine(RtmCommand:GetHelp());
	elseif ( arguments == "show" ) then		
		OpenPane();
	elseif ( arguments == "where" ) then		
		RtmCommand:Execute("BlablaCrane", "repeat ;loc");
	-- else
		-- local i, j = string.find(arguments, "repeat");
		-- if ( i==1 ) then		
			-- Turbine.Shell.WriteLine(ToUTF8("<rgb=#FF5CCD>BlaBlaCrane repete: ".. arguments .."</rgb>"));
		-- end
	end
end

function RtmCommand:GetHelp()
	return "BlaBlaCrane\nPas d'aide (pas le temps :D)\n";
end

function RtmCommand:GetShortHelp()
	return "TODO.";
end

function OpenPane()
	if(pimpYourTxtDlg ~= nil) then
		pimpYourTxtDlg:SetVisible(true);
	end
end

function SaveSettings()
	function SavesettingsConfirmation(sender, args)
		--Turbine.Shell.WriteLine(ToUTF8("<rgb=#FF5CCD>BlaBlaCrane: settings sauvegardés</rgb>"));
	end
	DataSave(Turbine.DataScope.Account, "BlaBlaCrane_settings", settings);
	if(quickLauncher) then quickLauncher:Applysettings(); end;
end

function Loadsettings()	
	local tmpsettings = DataLoad(Turbine.DataScope.Account, "BlaBlaCrane_settings");
	if(tmpsettings ~= nil) then
		settings = tmpsettings;		
	else
		Reinitsettings();
	end
end

function Reinitsettings()
	settings = {};
	local width, height = Turbine.UI.Display.GetSize();		
	-- local width2, height2;
	-- width2 = width/2 - 300/2;
	-- height2 = height/3 - 180/2;
	-- settings.main_x = width2;
	-- settings.main_y = height2;
	function ptr(sender, args)
		--
	end
	settings.quicklaunch_x = width/2;
	settings.quicklaunch_y = 20;
	settings.defaultOpacity = 60;
	settings.canMoveQuickLauncher = false;
	settings.useQuickLauncher = true;
	--settings.autoShowOnLaunch = false;
	settings.animateQuickLauncher = true;
	settings.blablaTime = 15;
	if(quickLauncher) then quickLauncher:Applysettings(); end;
end

Loadsettings();

plugin.GetOptionsPanel = function( self )
  	return BuildConfigDialog();
end

--pimpYourTxtDlg = PimpYourTextDialog();
quickLauncher = createQuickLauncher(nil);
if(settings.useQuickLauncher) then
	quickLauncher:Start();
	quickLauncher:Applysettings();
end
-- if(settings.autoShowOnLaunch) then
	-- pimpYourTxtDlg:Start()
-- end

Turbine.Shell.AddCommand( "BlaBlaCrane", RtmCommand );