DiceLister = class();

function DiceLister:Constructor()
	self:GetListMenu();
	self:InitChatLogger();
	self.total = 0;
end

function DiceLister:InitChatLogger()
	if(Turbine.Chat.receivedListerners == nil) then
		Turbine.Chat.receivedListerners = {};
		Turbine.Chat.Received = function (sender, args)
			for i, j in pairs(Turbine.Chat.receivedListerners) do
				j:OnReceived(sender, args);
			end
		end
		-- local tempMessage = tostring(args.Message);
	end
	if (Turbine.Chat.receivedListerners ~= nil) then
		for i, j in pairs(Turbine.Chat.receivedListerners) do
			if(j==self) then return; end
		end
		table.insert(Turbine.Chat.receivedListerners, self);
		--Turbine.Shell.WriteLine( "DiceLister ECHO: "..table.getn(Turbine.Chat.receivedListerners));
	end	
end

function DiceLister:OnReceived(sender, args)
	if args.ChatType == Turbine.ChatType.Standard then
		local tempMessage = tostring(args.Message);
		local x, y, name, value = string.find(tempMessage, "^(.*) a obtenu %(100%)\194\160: (.*)$");
		if(name~=nil ) then
			local nb = self:AddCounter(name, value, false);
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>"..name.." a fait ".. value .."</rgb>"); -- OK
		end
	end
end

function DiceLister:AddCounter(name, nb, force)
	-- test membership
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>name = "..name.." => "..nb.."</rgb>");
	local player = Turbine.Gameplay.LocalPlayer:GetInstance();
	if(player:GetName()==name or self:IsTeamMember(name) or force==true) then
		self.total = self.total+nb;
		local leaf = self:GetLeaf(name);
		if(leaf==nil)then
			leaf = Turbine.UI.MenuItem(name);
			leaf.name = name;
			leaf.value = tonumber(nb);
			leaf.pos = 1;
			for i=1, self.kmenu:GetItems():GetCount(), 1 do
				local bleaf =  self.kmenu:GetItems():Get(i);
				if(bleaf~=nil and bleaf.name~=nil and bleaf.value~=nil and bleaf.value<tonumber(nb)) then
					self.kmenu:GetItems():Insert(i, leaf);
					break;
				elseif(bleaf~=nil and bleaf.name==nil) then
					self.kmenu:GetItems():Insert(i, leaf);
					break;
				end
			end		
		else
			if(leaf.subvalue==nil)then
				leaf.subvalue = nb;
			else
				leaf.subvalue = nb .. ", "..leaf.subvalue;
			end
			for i=self.kmenu:GetItems():IndexOf(leaf)-1, 1, -1 do
				local bleaf =  self.kmenu:GetItems():Get(i);
				if(bleaf~=nil and bleaf.name~=nil) then
					--Turbine.Shell.WriteLine("<rgb=#FF5CCD>leaf.name="..leaf.name.." bleaf.name="..bleaf.name.."</rgb>");
					if(bleaf.value<leaf.value) then
						self.kmenu:GetItems():Set(i, leaf);
						self.kmenu:GetItems():Set(i+1, bleaf);
					end
				end
			end
		end
		
		-- update pos
		-- for i=self.kmenu:GetItems():GetCount(), 1, -1 do
			-- local leaf1 = self.kmenu:GetItems():Get(i);
			-- if(leaf1~=nil and leaf1.name~=nil) then
				-- for j=i-1, 1, -1 do
				
				-- end
			-- end
		-- end	
		
		-- Update texts
		for i=1, self.kmenu:GetItems():GetCount(), 1 do
			local leaf = self.kmenu:GetItems():Get(i);
			if(leaf~=nil and leaf.name~=nil) then
				--Turbine.Shell.WriteLine("<rgb=#FF5CCD>UPDATE "..leaf.name.."</rgb>");
				self:UpdateLeafText(leaf);
			end
		end	
		return leaf.nb;
	end
	return 0;
end

function DiceLister:IsTeamMember(playerName)
	local player = Turbine.Gameplay.LocalPlayer:GetInstance();
	if(player == nil or player:GetParty()==nil) then
		return false;
	end
	local party = player:GetParty();
	for i=1, party:GetMemberCount(), 1 do
		if(party:GetMember(i):GetName()==playerName) then
			return true;
		end
	end
	return false;
end

function DiceLister:UpdateLeafText(leaf)
	if(leaf~=nil and leaf.name~=nil) then
		--leaf:SetText(leaf.pos.." "..leaf.name..": "..leaf.nb.." ["..math.floor(100*leaf.nb/self.total).."%]");
		local subvalue = "";
		if(leaf.subvalue~=nil) then
			subvalue = "  ("..leaf.subvalue..")";
		end
		leaf:SetText(leaf.name..": "..leaf.value..subvalue);
	end
end

function DiceLister:GetLeaf(name)
	for i=1, self.kmenu:GetItems():GetCount(), 1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name==name) then
			return leaf;
		end
	end
	return nil;
end

function DiceLister:GetListMenu()
	if(self.kmenu == nil) then
		self.kmenu = Turbine.UI.MenuItem("Liste de dés");
		local dMenuList = self.kmenu:GetItems();
		local resetMenuItem = Turbine.UI.MenuItem( "Réinitialiser");
		resetMenuItem.Click = function (sender, args)
			self:Reset();
		end		
		dMenuList:Add(resetMenuItem);
		local shareMenuItem = Turbine.UI.MenuItem( "Partager ...");
		local shareCommMenuItem = Turbine.UI.MenuItem( "... à la communauté");
		shareCommMenuItem.Click = function (sender, args)
			self:Share("/f");
		end		
		shareMenuItem:GetItems():Add(shareCommMenuItem);
		local shareRaidMenuItem = Turbine.UI.MenuItem( "... au raid");
		shareRaidMenuItem.Click = function (sender, args)
			self:Share("/ra");
		end		
		shareMenuItem:GetItems():Add(shareRaidMenuItem);	
				local shareConfMenuItem = Turbine.UI.MenuItem( "... à la confrérie");
		shareConfMenuItem.Click = function (sender, args)
			self:Share("/k");
		end		
		shareMenuItem:GetItems():Add(shareConfMenuItem);	
		dMenuList:Add(shareMenuItem);
		if(_DEBUG~=nil and _DEBUG==true) then
			local test1MenuItem = Turbine.UI.MenuItem( "Add Toto");
			test1MenuItem.Click = function (sender, args)
				self:AddCounter("Toto", 15, true);
			end
			dMenuList:Add(test1MenuItem);
			local test2MenuItem = Turbine.UI.MenuItem( "Add Tata");
			test2MenuItem.Click = function (sender, args)
				self:AddCounter("Tata", 49, true);
			end
			dMenuList:Add(test2MenuItem);
			local test3MenuItem = Turbine.UI.MenuItem( "Add Titi");
			test3MenuItem.Click = function (sender, args)
				self:AddCounter("Titi", 85, true);
			end
			dMenuList:Add(test3MenuItem);
		end
	end
	return self.kmenu;
end

function DiceLister:Share(canal)
	local shareMsg = "<rgb=#FF0000>"..FromUTF8("Voici le palmarès des dés par BlablaCrane :").."<rgb=#FF5CCD>";
	local count = 0;
	for i=1, self.kmenu:GetItems():GetCount(), 1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name~=nil) then
			shareMsg = shareMsg.."\n"..i.." - "..leaf.name.." : "..leaf.value;
			if(leaf.subvalue~=nil) then
				shareMsg = shareMsg.." ("..leaf.subvalue..")";
			end					
			count = count+1;
		end
	end
	if(count==0) then
		shareMsg = shareMsg.."\n".. FromUTF8("Aucun dé n'a été detecté !");
	end
	createBubblePopupForSharing("421 !!!\nJ'ai gagné !", shareMsg, canal):SetVisible(true);
end

function DiceLister:Reset()
	self.total = 0;
	for i=self.kmenu:GetItems():GetCount(), 1, -1 do
		local leaf = self.kmenu:GetItems():Get(i);
		if(leaf~=nil and leaf.name~=nil) then
			self.kmenu:GetItems():RemoveAt(i);			
		end
	end
	self.total = 0;
end