 SkirmishDetector = class();
 
 function SkirmishDetector:Constructor()
	self:InitTargetLogger();
	self.canal = "/conf";
	self.lieutnentsData = {
		{"Archer perce-cœurs","Les dégâts de son sort Vague d'ombre sont repartis entre chaque personnes touchées par celle-ci."},
		{"Avaleur de chair", "Obtient un buff important s'il tue un joueur ou son soldat."},
		{"Berger de l'abject", "Invoque des vers abjects qui vont vous infliger un débuff qui ralentira votre vitesse d'attaque, de déclenchement et de déplacement qui se cumule jusqu'à 6 fois. Cette invocation ne peut être interrompue que par des stuns et des mezz."},
		{"Berseker hante-jours", "Invulnérable pendant 20 secondes : a root ou mezz pendant son invu."},
		{"Bourrasque glaciale", "Aggro aléatoire. Son aura réduit les resistances, et inflige des dégats. AoE très puissant."},
		{"Briseur de pierre de tonnerre", "Gros DoT au CaC. Lance des pierres pour stunner, puis inflige de gros dégats à la personne stunnée."},
		{"Briseur de volonté", "Inflige un débuff qui supprimera la moitié de la puissance maximale à son expiration."},
		{"Broyeur de pierres enragé", "Peut utiliser un buff qui lui confère +100% de dégâts de mêlée, -25% de durée d'attaque, +25% de vitesse de course et une immunité aux stuns, mezzs, roots et à la peur."},
		{"Brute tête-baissée", "Il possède un buff/débuff permanent qui diminue de moitié sa vitesse de course, mais augmente sa vitesse d'attaque et lui donne +500 % de bonus aux dégâts de mêlée."},
		{"Busard au regard acéré", "Aggro aléatoire. Possède un buff permanent qui augmente sa vitesse d'attaque et de déplacement, et il ne peut pas être ralenti."},
		{"Décourageur", "Lance un débuff qui réduit de moitié le moral maximum à son expiration."},
		{"Défenseur de l'infâme", "Possède une aura de défense (-50% de dommages reçus aux monstres alentours)."},
		{"Echo de l'au-delà", "A frapper en dernier. A chaque fois qu'il est frappé, un débuff peut être infligé au joueur le frappant, augmentant les dommages reçus de 100% pendant 25 secondes."},
		{"Émissaire de guerre", "Ne prendra aucuns dommages tant que tout les joueurs ne sont pas dans la zone de sa Vulnérabilité Sombre (+10% de tout types de dommages reçus)."},
		{"Fanatique de la douleur", "A tuer en dernier. Peut appliquer des buffs cumulables sur les ennemis, augmentant leur DPS. Il ne commencera à lancer ses buffs que lorsqu'il prendra des dégâts."},
		{"Faucheur des forêts", "Il ciblera très souvent les soldats. Il possède un buff de +30% de dégâts et –30% de vitesse d'attaque contre ces derniers."},
		{"Fauconnier maudit", " Immunisé contre tout les dommages, excepté lors une courte période après avoir tué un des ses crébains invoqués."},
		{"Flèche de sang venimeuse", "Décoche des flèches de Poison (dégâts importants à expiration), Blessure (perte de moral et de puissance à expiration), Peur (stun à expiration), et Maladie (perte de puissance à expiration)."},
		{"Frappeur massif", "Essaie de déclencher une compétence qui OS votre soldat ; si il y arrive chaque joueur dans la communauté perdra la possibilité d'invoquer ou de contrôler son soldat pour une minute."},
		{"Frère de la destruction", "Invoque des doubles de lui même (Un seul en duo et petite communauté, deux en communauté et 3 en raid). Concentrez vous sur un des Frère de la Destruction, sa mort entraînera celle de ses clones."},
		{"Freux sanglant", "Séparez le des autres monstres. Perçoit un bonus de dégâts et de dommages reçus pour chaque monstre l'entourant."},
		{"Fureur primordiale", "Commence avec peu de puissance, mais peut drainer la puissance des joueurs situés trop près."},
		{"Gardien des tempêtes Poings Bourrus", "Il s'agit d'un nain maître des runes spécialisé dans les attaques de foudre."},
		{"Maraudeur Ailenoire", "Utilise un débuff cumulable qui inflige un DoT d'ombre et augmente les dommages reçus de 25%."},
		{"Maraudeur enragé", "Il utilise un buff qui augmente grandement ses dégâts de mêlée, sa vitesse d'attaque, de course, et réduit de moitié les dommages reçus."},
		{"Monstre du chaos", "A tuer en priorité. Possède beaucoup de très gros skills très variés."},		
		{"Persécuteur au regard acéré", "TBD"},
		{"Porteur du fléau", "Peut infliger une maladie (+50% de dommages reçus et –50% de soins reçus), un poison (DoT), une blessure (impossible d'utiliser ses armes) ou une peur (-50% aux dégâts et –50% aux soins)."},
		{"Prêtre de la Vengeance", "Pas d'AoE : Donne a un allié un buff qui reflète 2 fois les dégâts qui lui sont faits. Ce buff dure 20 secondes."},
		{"Prêtresse des flammes", "Enflamme le sol sur une zone assez large, qui cause des dégâts de feu pour un moment."},
		{"Rage de Morgoth", "Chaque point de dégât fait a son moral est reporté pour un tiers a sa puissance. Peut aussi utiliser une puissante AOE d'ombre."},
		{"Reine de couvée", "Infecte un joueur avec un œuf, inflige des dommages d'acide dans un premier temps et ensuite invoque une petite araignée sur la position du joueur infecté."},
		{"Rejeton d'Angband", "Aura qui inflige un debuff de défense contre le feu."},
		{"Rince-chopes Poings Bourrus", "Bois de la bière de façon périodique afin d'augmenter ses dégâts, dommages reçus et chance d'échec."},
		{"Sangsue Gardienne", "Place un totem qui peut drainer votre vie pour le soigner."},
		{"Sapeur d'esprit", "Possède une aura qui ralentit énormément la vitesse de déplacement et d'attaque, ainsi que le temps de déclenchement des skills."},
		{"Semeur de haine dément", "Lance des buffs, sur les ennemis, qui augmentera la menace de certaines sources (en fonction de son moral restant, voir les commentaires) ainsi que sa vitesse de déplacement (Attendez vous à un désordre important dans les aggros)."},
		{"Semeur de mort", "A tuer en premier : Peut ramener les ennemis tombés au combat en tant qu'esprits déchus. Peut invoquer un esprit vengeur."},
		{"Tempête des flammes", "Possède une aura qui inflige d'importants DoT de feu, un débuff de vitesse d'attaque, de vitesse de course et de temps de déclenchement."},
		{"Tortue hargneuse enragée", "Se lance un buff cumulable qui lui donne +25% de dégâts et + 5% de vitesse de course et qui est uniquement débuffable par une manœuvre de communauté."},
		{"Trappeur blême", "Pose une zone de feu au sol."},
		{"Troll preneur de coups", "Peut soigner ses alliés aux dépends de sa propre santé."},
		{"Tueur silencieux", "Regroupez vous ! Se déplace furtivement, s'éclipse discrètement puis lance une attaque surprise qui cause de gros dégâts. Après quoi il essaiera de fuir et de s'éclipser a nouveau."},
		{"Barakaf", "Beau gosse poilu !"}	,
		{"Walm", "Beau gosse !"}	
	};
	self:GetMenu();
end

function SkirmishDetector:GetMenu()
	if(self.kmenu == nil) then
		self.kmenu = Turbine.UI.MenuItem("Détecteur de Lieutenants");
		local dMenuList = self.kmenu:GetItems();
		local shareMenuItem = Turbine.UI.MenuItem( "Canal de communication ...");
		local shareCommMenuItem = Turbine.UI.MenuItem( "... à la communauté");
		shareCommMenuItem.Click = function (sender, args)
			self.canal = "/f";
		end		
		shareMenuItem:GetItems():Add(shareCommMenuItem);
		local shareRaidMenuItem = Turbine.UI.MenuItem( "... au raid");
		shareRaidMenuItem.Click = function (sender, args)
			self.canal = "/ra";
		end		
		shareMenuItem:GetItems():Add(shareRaidMenuItem);	
				local shareConfMenuItem = Turbine.UI.MenuItem( "... à la confrérie");
		shareConfMenuItem.Click = function (sender, args)
			self.canal = "/k";
		end		
		shareMenuItem:GetItems():Add(shareConfMenuItem);	
		dMenuList:Add(shareMenuItem);	
	end
	return self.kmenu;
end

function SkirmishDetector:InitTargetLogger()
	if(Turbine.Gameplay.LocalPlayer.targetListerners == nil) then
		Turbine.Gameplay.LocalPlayer.targetListerners = {};
		local player=Turbine.Gameplay.LocalPlayer.GetInstance();
		player.TargetChanged = function (sender, args)
			for i, j in pairs(Turbine.Gameplay.LocalPlayer.targetListerners) do
				j:TargetChanged(sender, args);
			end
		end
		-- local tempMessage = tostring(args.Message);
	end
	if (Turbine.Gameplay.LocalPlayer.targetListerners ~= nil) then
		for i, j in pairs(Turbine.Gameplay.LocalPlayer.targetListerners) do
			if(j==self) then return; end
		end
		table.insert(Turbine.Gameplay.LocalPlayer.targetListerners, self);
		--Turbine.Shell.WriteLine( "SkirmishDetector ECHO: "..table.getn(Turbine.Gameplay.LocalPlayer.targetListerners));
	end	
end

function SkirmishDetector:TargetChanged(sender, args)
	local player=Turbine.Gameplay.LocalPlayer.GetInstance();
	local target=player:GetTarget();
	if(target~=nil) then
		--Turbine.Shell.WriteLine("<rgb=#FF5CCD>SkirmishDetector : ".. target:GetName() .."</rgb>");
		local name = target:GetName();
		for i=1 , table.getn(self.lieutnentsData) , 1 do
			-- if(i==1)then
				-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>TEST ".. self.lieutnentsData[i][1] .." == "..name.."</rgb>");
				-- TEST_ShowCharCode(self.lieutnentsData[i][1], false);
				-- TEST_ShowCharCode(name, false);
			-- end
			if(self.lieutnentsData[i][1]==name) then
				--Turbine.Shell.WriteLine("<rgb=#FF5CCD>SkirmishDetector : ".. self.lieutnentsData[i][2] .."</rgb>");
				--createQuickLauncher(nil):UpdateSkirmish(self.lieutnentsData[i]);
				--createBubblePopupForLieutenant(self.lieutnentsData[i], self.canal):SetVisible(true);
				createBubblePopupForSharing("Fiche, je le conais lui !\nC'est un "..self.lieutnentsData[i][1].." un Lieutenant de l'Oeil !",
											"<rgb=#FF0000>"..FromUTF8("BlaBlaCrane a détecté un Lieutenant : ".. self.lieutnentsData[i][1]) .. "\n<rgb=#FF5CCD>=> ".. FromUTF8(self.lieutnentsData[i][2]) .."</rgb>",
											self.canal):SetVisible(true);
				return self.lieutnentsData[i];
			end
		end
		createBubblePopupForLieutenant(nil);
	end	
end

